kind: "Template"                                              
apiVersion: "v1"
metadata:
  name: linkextractor-template
  anotations:
    openshift.io/display-name: "Linkextractor Example"
    description: >-
      This template is defined by objects created by openshift, such as deploymentconfig, service and route for a web application
      written in python called linkextractor.
labels: 
  app: link-extractor
objects:
- kind: DeploymentConfig
  apiVersion: v1
  metadata:
    name: link-extractor
  labels:
    app: link-extractor
  spec:
    replicas: "${{REPLICA_COUNT}}"
    selector:
      app: link-extractor     
    strategy:
      type: Recreate
      recreateParams:
        timeoutSeconds: 600
      activeDeadlineSeconds: 3600
    triggers:
      - type: ConfigChange  
    template:
        metadata:
          labels:
            app: link-extractor
        spec:
          containers:
            - env: 
                - name: "REDEPLOY"
                  value: "${REDEPLOY}"
              name: link-extractor
              #image: "python:3"
              image: registry.gitlab.com/nik1_9alex9_9jd/link-extractor:master
              ports:
                - containerPort: 5000
                  protocol: TCP
              terminationMessagePath: /dev/termination-log
              terminationMessagePolicy: File
              imagePullPolicy: Always
              readinessProbe:
                tcpSocket:
                  port: 5000 
                initialDelaySeconds: 10
                periodSeconds: 10
                timeoutSeconds: 21
              livenessProbe:
                tcpSocket:
                  port: 5000
                initialDelaySeconds: 40
                periodSeconds: 20 
                timeoutSeconds: 41
          restartPolicy: Always
          dnsPolicy: ClusterFirst
          schedulerName: default-scheduler  
- kind: Service
  apiVersion: v1
  metadata:
    name: link-extractor
    labels:
      app: link-extractor
  spec:
    type: ClusterIP
    ports:
      - name: 5000-tcp
        port: 5000
        protocol: TCP
        targetPort: 5000
    selector:
      app: link-extractor
- kind: Route
  apiVersion: route.openshift.io/v1
  metadata:
    name: linkextractor
    labels:
      app: link-extractor
    annotations:
      openshift.io/host.generated: 'true'
  spec:
    host: linkextractor-linkextractor.apps.us-east-1.online-starter.openshift.com
    to:
      kind: Service
      name: link-extractor
      weight: 100
    wildcardPolicy: None
    port:
      targetPort: 5000-tcp
parameters: 
  - name: REPLICA_COUNT
    value: "1"
  - name: "REDEPLOY"
    value: "0"
    